/* Copyright (C) 2005-2007 VA007219 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <tchar.h>

int dbgprintf(_TCHAR *fmt,...);

BOOL exec(LPPROCESS_INFORMATION ProcessInformation,_TCHAR *path,_TCHAR *cmdline)
{
    SECURITY_ATTRIBUTES ProcessAttributes;
    SECURITY_ATTRIBUTES ThreadAttributes;
    STARTUPINFO StartupInfo;
    BOOL sts;

    ProcessAttributes.nLength = sizeof ProcessAttributes;
    ProcessAttributes.lpSecurityDescriptor = NULL;
    ProcessAttributes.bInheritHandle = TRUE;
    ThreadAttributes.nLength = sizeof ThreadAttributes;
    ThreadAttributes.lpSecurityDescriptor = NULL;
    ThreadAttributes.bInheritHandle = TRUE;
    GetStartupInfo(&StartupInfo);
    StartupInfo.dwFlags = STARTF_USESHOWWINDOW;
    StartupInfo.wShowWindow = SW_HIDE;
    sts = CreateProcess(path,// s\W[̖O
      cmdline,               // R}hC̕
      &ProcessAttributes,    // ZLeBLqq
      &ThreadAttributes,     // ZLeBLqq
      TRUE,                  // nȟpIvV
      CREATE_DEFAULT_ERROR_MODE | NORMAL_PRIORITY_CLASS,// 쐬̃tO
      NULL,                  // VubN
      NULL,                  // JgfBNg̖O
      &StartupInfo,          // X^[gAbv
      ProcessInformation    // vZX
      );
    return sts;
}

HANDLE hThread;
HANDLE hProcess;

int run(_TCHAR *path,_TCHAR *cmdline)
{
    PROCESS_INFORMATION ProcessInformation;
    int ret;
    DWORD ExitCode;
    _TCHAR *cmdbuf;
    int e;
    _TCHAR *p;

    e = 0;
    if ( path != NULL ) {
        if ( cmdline != NULL ) {
            cmdbuf = malloc((_tcslen(path) + _tcslen(cmdline) + 2) * sizeof(_TCHAR));
            _tcscpy(cmdbuf,path);
            _tcscat(cmdbuf,_T(" "));
            _tcscat(cmdbuf,cmdline);
        } else {
            cmdbuf = malloc((_tcslen(path) + 2) * sizeof(_TCHAR));
            _tcscpy(cmdbuf,path);
        }
    } else {
        cmdbuf = cmdline;
    }
    ret = exec(&ProcessInformation,path,cmdbuf);
/*dbgprintf(_T("line=%d path=%s cmdline=%s cmdbuf=%s ret=%d"),__LINE__,path,cmdline,cmdbuf,ret);
*/
    for ( p = cmdline ; *p ; p++ ) {
        *p = 0;
    }
    if ( cmdbuf != cmdline ) {
        for ( p = cmdbuf ; *p ; p++ ) {
            *p = 0;
        }
        free(cmdbuf);
    }
    if ( ret == 0 ) {
        e = 255;
    } else {
        ret = WaitForSingleObject(ProcessInformation.hProcess, INFINITE);
        if ( ret == WAIT_FAILED ) {
            e = 255;
        } else if ( ret == WAIT_ABANDONED ) {
            e = 255;
        } else if ( ret == WAIT_TIMEOUT ) {
            hThread = ProcessInformation.hThread;
            hProcess = ProcessInformation.hProcess;
            return 256;
        } else {
            ret = GetExitCodeProcess(ProcessInformation.hProcess,&ExitCode); 
            if ( ret == 0 ) {
                e = 255;
            } else {
                if ( ExitCode == STILL_ACTIVE ) {
                }
            }
        }
        CloseHandle(ProcessInformation.hThread) ;
        CloseHandle(ProcessInformation.hProcess) ;
    }
    if ( e ) {
        return e;
    } else {
        return ExitCode;
    }
}
