/* Copyright (C) 2005-2007 VA007219 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <io.h>
#include <conio.h>
#include <windows.h>
#include <tchar.h>

#ifndef UNICODE
#define iskanji(x) IsDBCSLeadByte((BYTE)x)
#define bom(x)
#else
#define iskanji(x) 0
#undef _ftprintf
#define _ftprintf u_ftprintf
#undef _tprintf
#define _tprintf u_tprintf
int u_ftprintf(FILE *fp,const _TCHAR *format,...);
int u_tprintf(const _TCHAR *format,...);
int bom(FILE *fp);
#endif

#define STRINGIFY(s)   STRINGIFY_(s)
#define STRINGIFY_(s)  #s

int run(_TCHAR *path,_TCHAR *cmdline);

#ifdef DEBUG
_TCHAR dbgbuff[8192];

int dbgprintf(_TCHAR *fmt,...)
{
    va_list argp;
    int ret;
    int sts;

    if ( fmt != NULL && *fmt != 0 ) {
        va_start(argp, fmt);
        ret = _vsntprintf(dbgbuff,sizeof dbgbuff / sizeof dbgbuff[0] - 1,fmt,argp);
        va_end(argp);
    }
    OutputDebugString(dbgbuff);
    return ret;
}

void dumpe(unsigned char *buff,unsigned n)
{
    int i;
    FILE *fp;

        i = 0;
        if ( n == 0 ) {
            fprintf(stderr,":%x  len=%d\n",buff,n);
            return;
        }
        while ( n ) {
            if ( i == 0 ) {
                fprintf(stderr,":%x  ",buff);
            }
            fprintf(stderr,"%02x ",*buff++);
            i++;
            if ( i == 16 ) {
                fprintf(stderr,"\n");
                i = 0;
            }
            n--;
        }
        fprintf(stderr,"\n");
}
#else
int dbgprintf(_TCHAR *fmt,...)
{
    return 0;
}

void dumpe(unsigned char *buff,unsigned n)
{
    return;
}
#endif

_TCHAR *pgname;

/*
int _tmain(int argc,_TCHAR **argv)
*/
int WINAPI WinMain(HINSTANCE hInstance,// ݂̃CX^X̃nh
  HINSTANCE hPrevInstance,  // ȑÕCX^X̃nh
  LPSTR lpCmdLine,          // R}hC
  int nCmdShow              // \
)
{
    _TCHAR *p;
    _TCHAR *q;
    int ec;
    int sts;

    q = p = _tcsdup(GetCommandLine());
    while ( *p == ' ' ) p++;
    if ( *p == 0 ) {
        ;
    } else if ( *p == '"' ) {
        ec = '"';
        p++;
    } else {
        ec = ' ';
    }
    while ( *p ) {
        if ( *p == ec ) {
            if ( *p == ' ' ) {
                *p = 0;
                p++;
                break;
            } else {
                *p = 0;
                p++;
                break;
            }
        }
        p++;
    }
    while ( *p == ' ' ) p++;
    sts = run(NULL,p);
    free(q);
    return sts;
}
